package form.data;

import form.io.*;
import form.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.io.*;

public class FileData implements Serializable {

	public static String LINK = "<link=";
	public static String FILE = "<file=";
	public static String LINE = "<line=";
	public static String END = "\\>";
	public static String NEWFILE = "***NEW***\n";

	public final static String prefix = "file";

	private String file = "";

	public FileData(){
	}

	public String getFiles(Viewer viewer){
		int findex =0;
		int lindex =0;
		int cindex =0;
		int next =0;
		String name;
		String newData="";
		String data = file;

		while (data.length()>0){
			//find the next potential element
			findex = data.indexOf(FILE);
			lindex = data.indexOf(LINK);
			cindex = data.indexOf(LINE);
			//System.out.println("f l c"+findex+" "+lindex+" "+cindex);

			if ( cindex == 0){
				name = data.substring(LINE.length(),data.indexOf(END));
				if (check(name,viewer))
					data = data.substring(data.indexOf(END)+END.length());
				else
					data = data.substring(data.indexOf("\n"));
			}
			else if ( findex == 0){
				name = data.substring(FILE.length(),data.indexOf(END))+"\n";
				data = data.substring(data.indexOf(END)+END.length()+1);
				newData+=NEWFILE+name;
			}
			else if ( lindex == 0){
				name = data.substring(LINK.length(),data.indexOf(END));
				data = data.substring(data.indexOf(END)+END.length());
				newData += viewer.getComp(name).getText();
			}
			else{
				next = min(cindex,findex,lindex);
				if (next == -1) next = data.length();
				newData+=data.substring(0,next);
				data = data.substring(next);
				//System.out.println("DATA "+next+" "+newData+"\n"+data);
			}
		}
		return newData;
	}

	private int min(int a, int b, int c){
		int min = a;
		if ((min <0 ) || ((b>0) && (min > b)))
			min = b;
		if ((min <0 ) || ((c>0) && (min > c)))
			min = c;

		return min;
	}

	boolean check(String data,Viewer v){ 
		if (data.indexOf("<=")> 0){
			if (getLeft(data,"<=",v) <= getRight(data,"<="))
				return true;
			else 
				return false;
		}
		else if (data.indexOf(">=")> 0){
			if (getLeft(data,">=",v) >= getRight(data,">="))
				return true;
			else 
				return false;
		}
		else if (data.indexOf("==")> 0){
			if (getLeft(data,"==",v) == getRight(data,"=="))
				return true;
			else 
				return false;
		}
		else if (data.indexOf("=")> 0){
			if (getLeft(data,"=",v) == getRight(data,"="))
				return true;
			else 
				return false;
		}
		else if (data.indexOf("<")> 0){
			if (getLeft(data,"<",v) < getRight(data,"<"))
				return true;
			else 
				return false;
		}
		else if (data.indexOf(">")> 0){
			if (getLeft(data,">",v) > getRight(data,">"))
				return true;
			else 
				return false;
		}
		else //not good
			return false;
	}

	int getLeft(String data,String oper,Viewer v){
		data = data.substring(0,data.indexOf(oper));
		int val = Integer.valueOf(v.getComp(data).getText()).intValue();
		return val;
	}
	
	int getRight(String data,String oper){
		data = data.substring(data.indexOf(oper)+oper.length());
		int val = Integer.valueOf(data).intValue();
		return val;
	}
	



	public void save(ToHtml save){
		String temp = file;
        int next = temp.indexOf("\n");
	 	int count = 0;

        while (next>=0){
        	save.add(prefix+count++,"."+temp.substring(0,next)+".");

            temp = temp.substring(next+1);
            next = temp.indexOf("\n");

        }
        if (temp.length() >0)
        save.add(prefix+count++,temp);
	}
	
	public void setText(String text){
	   file= text;
	}

	public String getText(){ return file;}

	//Initializes the data for use in submitting forms
	public void open(Open open){

		file = "";
		int count = 0;
		String   line = "";
		  while ( (line = open.getParameter(prefix+count++)) != null ){
		     file += line.substring(1,line.length()-1)+"\n";
		  }

	}

}
