package form.edit;

import form.*;
import form.data.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class OutputEditor extends Frame implements  Serializable, ActionListener, MouseListener{

   private TextArea   compList  = null;
   private TextArea   output  = null;
   private Viewer viewer = null;

   public Dimension getPreferredSize(){
                return new Dimension(430,600);
   }


   //add validate button to create a data object
   public OutputEditor (Viewer viewer){
	super("Output Editor");
	this.viewer = viewer;

	setLocation(600,0);

	new WindowCloser(((Window)this));
      	setSize(getPreferredSize());
      	setLayout(new FlowLayout());

	  
	  add(new Label("Components currentally in form"));

	  Button refresh = new Button("refresh");
	  refresh.addActionListener(this);
	  add(refresh);

	  compList  = new TextArea(11,45);
	  compList.setVisible(true);
	  compList.setEditable(false);
	  compList.addMouseListener(this);
	  add(compList);

	  output  = new TextArea(20,45);
	  output.setVisible(true);
	  add(new Label("The format for the file(s) to be sent to the server"));
	  add(output);

	  Button hide = new Button("Close");
	  hide.addActionListener(this);
	  add(hide);

	  

	  //setVisible(true);
	}

	public void setText(String fileData){
	  output.setText(fileData);
	}

	public String getText(){
	   return output.getText();
	}

	private void refreshList(){
	    //make wrap
	    String comps = viewer.getComps();
		String data ="";
		int next;

		while (comps !=null){
			next = comps.indexOf(" ",40);
			if (next > 0){
				data += comps.substring(0,next)+"\n";
				comps = comps.substring(next+1);
			} else{
				data += comps;
				comps = null;
			}
		}
			
	    compList.setText(data);
	}

        public void actionPerformed(ActionEvent e) {

	    if (e.getActionCommand().equals("Close")){
		setVisible(false);
	    }

	    if (e.getActionCommand().equals("refresh")){
	      refreshList();
	    }
	}

  public void mouseClicked(MouseEvent e) {
	if ( (e.getComponent() == compList) && (e.getClickCount() == 2) ) {
	   String newLink = compList.getSelectedText();
	   if (newLink != null){
	      String oldText = output.getText();
	      int insertPos = output.getCaretPosition();
	      String newText = oldText.substring(0,insertPos);
	      newText +=FileData.LINK+newLink+FileData.END+oldText.substring(insertPos);
	      output.setText(newText);
	      output.setCaretPosition(insertPos+(FileData.LINK+newLink+FileData.END).length());


	    }
	}
	 
  }

  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) { }

  public void mouseReleased(MouseEvent e) {}

}
